<?php
// +-----------------------------------------------------------------------+
// | Mod Name : BlobThumbnails                                             |
// | Mod Version : 1.3                                                     |
// | Mod Version author : FlipFlip <flipflip@free.fr>                      |
// | Mod description :                                                     |
// | Ce module permet la copie de la vignette dans un champ blob           |
// | pour pouvoir la réupérer par CrystalReport                            |
// +-----------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or modify  |
// | it under the terms of the GNU General Public License as published by  |
// | the Free Software Foundation                                          |
// |                                                                       |
// | This program is distributed in the hope that it will be useful, but   |
// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
// | General Public License for more details.                              |
// |                                                                       |
// | You should have received a copy of the GNU General Public License     |
// | along with this program; if not, write to the Free Software           |
// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
// | USA.                                                                  |
// +-----------------------------------------------------------------------+

class BlobThumbnails {
  var $plugin_name, $plugin_path, $plugin_url;

  function BlobThumbnails($plugin_name, $plugin_path, $plugin_url) {
    // Args
    $this->plugin_name = $plugin_name;
    $this->plugin_path = $plugin_path;
    $this->plugin_url = $plugin_url;
    // handler
    $this->initialize_event_handler($plugin_name, $plugin_path, $plugin_url);
  }
  
  function initialize_event_handler() {
  	$this->load_lang(); // Chargement des langues
  	
    add_event_handler('add_elements', array(&$this, 'AjoutBlob'));
    add_event_handler('delete_elements', array(&$this, 'DeleteBlob'));

    if (is_admin()) {
      // ---- Administration
      add_event_handler('get_admin_plugin_menu_links', array(&$this, 'plugin_admin_menu')); // Menu d'administration
    } 
  }  

  // Affichage du lien dans la barre
  // menu administrateur
  function plugin_admin_menu($menu) {
    array_push($menu,
      array(
        'NAME' => 'BlobThumbnails',
        'URL' => get_admin_plugin_menu_link($this->plugin_path.'admin/BlobThumbnailsAdmin.php')
      )
    );
    return $menu;
  }  

  // Chargement des fichiers langues
  function load_lang() {
    load_language('plugin.lang', $this->plugin_path);
  }
  
  function AjoutBlob($inserts) {
    global $conf, $prefixeTable;
    
    $exts = array('pdf', 'PDF', 'xls', 'XLS', 'doc', 'DOC', 'pps', 'PPS', 'ppt', 'PPT', 'ai', 'AI', 'eps', 'EPS', 'wmv', 'WMV', 'wma', 'WMA', 'mpg', 'MPG', 'mpeg', 'MPEG');
    
    foreach($inserts as $cle => $file) {
      $dirname = dirname($file['path']);

      $name = explode('.', $file['file']);
      $ext = $name[1];
      $filename = $name[0];
      
      if(!in_array($ext, $exts)) {      
        $handle = fopen($dirname.'/thumbnail/'.$conf['prefix_thumbnail'].$filename.'.'.$file['tn_ext'], 'rb');
        $content = addslashes(fread($handle, filesize($dirname.'/thumbnail/'.$conf['prefix_thumbnail'].$filename.'.'.$file['tn_ext'])));
        fclose ($handle);
                	
        $query = '
          INSERT INTO '.$prefixeTable.'image_blobthumbnails(id, name, contents) 
          VALUES('.$file['id'].', "'.$name[0].'", "'.$content.'")
        ;';
      
        pwg_query($query);
      }    	
    }
  }
  
  function DeleteBlob($ids) {
  	global $prefixeTable;
  	$query = '
  	  DELETE FROM '.$prefixeTable.'image_blobthumbnails
  	  WHERE id IN(
  	    '.wordwrap(implode(', ', $ids), 80, "\n").')
      ;';
  	
  	pwg_query($query);
  }
}
?>
